﻿
function Lifebloomer_OnLoad()
	SlashCmdList["LIFEBLOOMER"] = Lifebloomer_SlashCommand;
	SLASH_LIFEBLOOMER1 = "/Lifebloomer";
	SLASH_LIFEBLOOMER2 = "/lifebloomer";
	SLASH_LIFEBLOOMER2 = "/LB";
	SLASH_LIFEBLOOMER2 = "/Lb";
	SLASH_LIFEBLOOMER2 = "/lb";
	LBVplayername, LBVrealm = UnitName("player");
	loc, LBVClass = UnitClass("player");
	LBV = {};
	LBV[1] = {};
	LBV[1].Unitid = "target";
	LBV[1].Time = 0;
	LBV[1].Name = "Target";
	LBV[1].Stacks = 0;
	LBVFF = 0;
	DEFAULT_CHAT_FRAME:AddMessage(">> Lifebloomer Loaded.  Type |cFFFFFFFF/lifebloomer|r for help.", 0, 1, 0);
end

function Lifebloomer_UnitFrame_OnEnter()
	if ( SpellIsTargeting() ) then
		SetCursor("CAST_CURSOR");
	end
	local unitid = this:GetAttribute("unit");
	if ( SpellIsTargeting() and not SpellCanTargetUnit(unitid) ) then
		SetCursor("CAST_ERROR_CURSOR");
	end
end

function Set_LBTarget(tar, unit, parent)
	if unit == 0 then
		unit = ID_Unit(tar);
	end
	if ( not ( unit == nil ) ) then
		local id = (parent):GetID();
		LBV[id].Unitid = unit;
		local name, realm = UnitName(unit);
		LBV[id].Name = name;
		if not (name == nil) then
			(parent):SetAttribute("unit", unit);
			getglobal(((parent):GetName()).."HPBarName"):SetText(name);
		elseif LBV[id].Unitid == "focus" then
			getglobal(((parent):GetName()).."HPBarName"):SetText("Focus");
			LBV[id].Name = "Focus";
		elseif LBV[id].Unitid == "target" or unit == "target" then
			(parent):SetAttribute("unit", "target");
			getglobal(((parent):GetName()).."HPBarName"):SetText("Target");
			LBV[id].Name = "Target";
		end
	end
end

function Lifebloomer_OnUpdate(elapsed)
	this.TimeSinceLastUpdate = this.TimeSinceLastUpdate + elapsed;
	local id = this:GetParent():GetID();
	
	while this.TimeSinceLastUpdate > 0.05 do
		this.TimeSinceLastUpdate = this.TimeSinceLastUpdate - 0.05;
		LBV[id].Time = LBV[id].Time - 0.05;
		if LBV[id].Time < 0 then
			LBV[id].Stacks = 0;
			getglobal(this:GetName().."Number"):SetText("");
			getglobal(this:GetName().."Timer"):SetText("");
		end
		local i = 1;
		while i > 0 do
			if UnitExists(LBV[id].Unitid) then
				local name, rank, iconTexture, count, duration, timeLeft = UnitBuff(LBV[id].Unitid,i,1);
				if name == nil then
					this:SetValue(0);
					getglobal(this:GetName().."Number"):SetText("");
					getglobal(this:GetName().."Timer"):SetText("");
					i = 0;
				elseif timeLeft and name == "Lifebloom" then
					local down, up, lag = GetNetStats();
					timeLeft = timeLeft - lag/1000;
					if timeLeft <= 0 then
						timeLeft = 0;
					elseif timeLeft + lag/1000 < 1 then
						this:SetStatusBarColor(.75, 0, 0, .8);
					elseif timeLeft < 1 then
						this:SetStatusBarColor(.5, 0, .5, .8);
					else this:SetStatusBarColor(0, .2, .5, .8);
					end
					LBV[id].Stacks = count;
					LBV[id].Time = timeLeft;
					getglobal(this:GetName().."Number"):SetText(count);
					getglobal(this:GetName().."Timer"):SetText(floor(timeLeft*10)/10);
					this:SetValue(timeLeft*20);
					i = 0;
				elseif i > 100 then
					this:SetValue(0);
					getglobal(this:GetName().."Number"):SetText("");
					getglobal(this:GetName().."Timer"):SetText("");
					i = 0;
				else
					i = i + 1;
				end
			else
				this:SetValue(0);
				getglobal(this:GetName().."Number"):SetText("");
				getglobal(this:GetName().."Timer"):SetText("");
				i = 0;
			end
		end
	end
end

function Lifebloomer_HealthUpdate()
	local unit = (this:GetParent()):GetAttribute("unit");
	local health = UnitHealth(unit)/(UnitHealthMax(unit)+0.01)*100;
	this:SetValue((health));
end

function Lifebloomer_GCDUpdate(elapsed)
	this.TimeSinceLastUpdate = this.TimeSinceLastUpdate + elapsed;
	while this.Time >= 0 and this.TimeSinceLastUpdate > 0.05 do
		this.TimeSinceLastUpdate = this.TimeSinceLastUpdate - 0.05;
		this.Time = this.Time - 0.05;
		this:SetValue(this.Time*100);
	end
	if this.Time < 0 then
		this:RegisterEvent("SPELL_UPDATE_COOLDOWN");
	end
end

function Lifebloomer_OnEvent(event, arg1, arg2, arg3, arg4, arg5)
	if event == "PLAYER_TARGET_CHANGED" then
		if this:GetAttribute("unit") == "target" then
			Set_LBTarget(0, "target", this);
		end
	elseif event == "PLAYER_FOCUS_CHANGED" then
		if this:GetAttribute("unit") == "focus" then
			Set_LBTarget(0, "focus", this);
		end
	end
end

function Lifebloomer_GCD_Event()
	if LBVClass == "DRUID" then
		this:UnregisterEvent("SPELL_UPDATE_COOLDOWN");
		local s, t, e = GetSpellCooldown("Lifebloom");
		LifebloomerMainFrameGCDBar.Time = t;
		LifebloomerMainFrameGCDBar:SetValue(LifebloomerMainFrameGCDBar.Time*100);
		LifebloomerMainFrameGCDBar.TimeSinceLastUpdate = 0;
	end
end

function ID_Unit(unit)
	if not UnitExists(unit) then
		return "target";
	elseif UnitIsUnit(unit, "focus") then
		return "focus";
	elseif UnitIsUnit(unit, "player") then
		return "player";
	elseif UnitIsUnit(unit, "pet") then
		return "pet";
	elseif UnitInRaid(unit) or UnitInParty(unit) then
		local name, realm = UnitName(unit);
		return name
	elseif UnitPlayerOrPetInRaid(unit) then
		for i=1, 40, 1 do
			if UnitIsUnit(unit, "raidpet"..i) then
				local name, realm = UnitName("raid"..i);
				return name.."-pet"
			end
		end
	elseif UnitPlayerOrPetInParty(unit) then
		for i=1, 4, 1 do
			if UnitIsUnit(unit, "partypet"..i) then
				local name, realm = UnitName("party"..i);
				return name.."-pet"
			end
		end
	else return "target" end
end

function Lifebloomer_AddFrame()
	local n = this:GetParent():GetID() + 1;
	local nt = getn(LBV) + 1;
	if LBVFF == 0 then
		local NewFrame = CreateFrame("Button", "LifebloomerMainFrameUnitFrame"..nt, LifebloomerMainFrame, "LifebloomerUnitTemplate");
		NewFrame:SetID(nt);
		NewFrame:SetPoint("TOP", "LifebloomerMainFrameUnitFrame"..(nt-1), "BOTTOM");
	else
		getglobal("LifebloomerMainFrameUnitFrame"..nt):Show();
		getglobal("LifebloomerMainFrameUnitFrame"..nt):SetAttribute("unit", "target");
		getglobal("LifebloomerMainFrameUnitFrame"..nt):RegisterEvent("PLAYER_FOCUS_CHANGED");
		getglobal("LifebloomerMainFrameUnitFrame"..nt):RegisterEvent("PLAYER_TARGET_CHANGED");
		LBVFF = LBVFF - 1;
	end
	tinsert(LBV, n, {});
	LBV[n] = {};
	LBV[n].Unitid = "target";
	LBV[n].Time = 0;
	LBV[n].Name = "Target";
	LBV[n].Realm = nil;
	LBV[n].Stacks = 0;
	for i=n, nt, 1 do
		Set_LBTarget(nil, LBV[i].Unitid, getglobal("LifebloomerMainFrameUnitFrame"..i));
	end
	LifebloomerMainFrame:SetHeight(LifebloomerMainFrame:GetHeight() + 40);
end

function Lifebloomer_RemoveFrame(parent)
	local nt = getn(LBV);
	if nt == 0 then
		LifebloomerMainFrame:Hide();
		DEFAULT_CHAT_FRAME:AddMessage(">> |cFFFFFFFFl|rife|cFFFFFFFFb|rloomer Hidden.", 0, 1, 0);
		return
	end
	local n1 = (parent):GetID();
	tremove(LBV, n1);
	for i=n1, nt-1, 1 do
		Set_LBTarget(0, LBV[i].Unitid, getglobal("LifebloomerMainFrameUnitFrame"..i));
	end
	getglobal("LifebloomerMainFrameUnitFrame"..nt):Hide();
	getglobal("LifebloomerMainFrameUnitFrame"..nt):UnregisterEvent("PLAYER_FOCUS_CHANGED");
	getglobal("LifebloomerMainFrameUnitFrame"..nt):UnregisterEvent("PLAYER_TARGET_CHANGED");
	LBVFF = LBVFF + 1;
	LifebloomerMainFrame:SetHeight(LifebloomerMainFrame:GetHeight() - 40);
end

function Lifebloomer_SlashCommand(cmd)
	if cmd == "reset" or cmd == "r" then
		--DEFAULT_CHAT_FRAME:AddMessage(">> /|cFFFFFFFFl|rife|cFFFFFFFFb|rloomer |cFFFFFFFFr|reset |cFFFFFFFF - Reset|r", 0, 1, 0);
	elseif cmd == "show" or cmd == "s" then
		DEFAULT_CHAT_FRAME:AddMessage(">> /|cFFFFFFFFl|rife|cFFFFFFFFb|rloomer |cFFFFFFFFs|rhow |cFFFFFFFF - Show|r", 0, 1, 0);
		LifebloomerMainFrame:Show();
	elseif cmd == "hide" or cmd == "h" then
		DEFAULT_CHAT_FRAME:AddMessage(">> /|cFFFFFFFFl|rife|cFFFFFFFFb|rloomer |cFFFFFFFFh|ride |cFFFFFFFF - Hide|r", 0, 1, 0);
		LifebloomerMainFrame:Hide();
	else
		Lifebloomer_CommandList();
	end
end

function Lifebloomer_CommandList()
	DEFAULT_CHAT_FRAME:AddMessage("> Commands:", 1, 1, 1);
	DEFAULT_CHAT_FRAME:AddMessage(">> /|cFFFFFFFFl|rife|cFFFFFFFFb|rloomer |cFFFFFFFF - Command List|r", 0, 1, 0);
	DEFAULT_CHAT_FRAME:AddMessage(">> /|cFFFFFFFFl|rife|cFFFFFFFFb|rloomer |cFFFFFFFFs|rhow |cFFFFFFFF - Show|r", 0, 1, 0);
	DEFAULT_CHAT_FRAME:AddMessage(">> /|cFFFFFFFFl|rife|cFFFFFFFFb|rloomer |cFFFFFFFFh|ride |cFFFFFFFF - Hide|r", 0, 1, 0);
	--DEFAULT_CHAT_FRAME:AddMessage(">> /|cFFFFFFFFl|rife|cFFFFFFFFb|rloomer |cFFFFFFFFr|reset |cFFFFFFFF - Reset|r", 0, 1, 0);
end